Введение
============

В наши дни программное обеспечение обычно распространяется в виде сервисов, называемых *веб-приложения* (web apps) или *software-as-a-service* (SaaS). Приложение двенадцати факторов — это методология для создания SaaS-приложений, которые:

* Используют **декларативный** формат для описания процесса установки и настройки, что сводит к минимуму затраты времени и ресурсов для новых разработчиков, подключённых к проекту;
* Имеют **соглашение** с операционной системой, предполагающее **максимальную переносимость** между средами выполнения;
* Подходят для **развёртывания** на современных **облачных платформах**, устраняя необходимость в серверах и системном администрировании;
* **Сводят к минимуму расхождения** между средой разработки и средой выполнения, что позволяет использовать **непрерывное развёртывание** (continuous deployment) для максимальной гибкости;
* И могут **масштабироваться** без существенных изменений в инструментах, архитектуре и практике разработки.

Методология двенадцати факторов может быть применена для приложений, написанных на любом языке программирования и использующих любые комбинации сторонних служб (backing services) (базы данных, очереди сообщений, кэш-памяти, и т.д.).
